unit Anima;

// TAnima version 2.00
// Freeware Component for D3,D4,D5,D6
// Copyright  2000-2001 by Peric
// Birthday of Component 07.04.2001.
// E-mail: pericddn@ptt.yu
// If I' find any errors or rubbish in TAnima please send me Your suggest or Reclamation.

interface

{$IFDEF VER90}
  {$DEFINE PDJ_D2}
{$ELSE}
{$IFDEF VER100}
  {$DEFINE PDJ_D3}
{$ELSE}
  {$IFDEF VER120}
    {$DEFINE PDJ_D4}
  {$ELSE}
    {$DEFINE PDJ_D5Up}
  {$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE PDJ_D6}
{$ENDIF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs,EXtCtrls,MMSystem{$IFNDEF PDJ_D3}, ImgList {$ENDIF};

  {$R Anima.res}

type
  TOnMouseOverEvent = procedure(Sender: TObject) of object;
  TOnMouseOutEvent = procedure(Sender: TObject) of object;
  TSpeed = 1..400;
  TAnima = class(TGraphicControl)

   private

    FPlay:boolean;
    FSpeed:TSpeed;
    Timer:TTimer;
    FCop: string;
    x:integer;
    FOnMouseOver: TOnMouseOverEvent;
    FOnMouseOut: TOnMouseOutEvent;
    FImages: {$IFNDEF PDJ_D3} TCustomImageList {$ELSE} TImageList {$ENDIF};
    FImageChangeLink: TChangeLink;
    procedure ImageListChange(Sender: TObject);
    procedure SetImages(Value: {$IFNDEF PDJ_D3} TCustomImageList {$ELSE} TImageList {$ENDIF});
    function GetCop: string;
    procedure SetCop(const Value: string);
    procedure CmVisibleChanged(var Message: TWmNoParams);
        message CM_VISIBLECHANGED;
    procedure CmColorChanged(var Message: TWMNoParams);
        message CM_PARENTCOLORCHANGED;
    procedure CMMouseEnter(var AMsg: TMessage);
              message CM_MOUSEENTER;
    procedure CMMouseLeave(var AMsg: TMessage);
              message CM_MOUSELEAVE;

  protected

    Procedure Animate;
    Procedure RunAni;
    procedure SetPlay(APlay:boolean);
    procedure SetSpeed(value:TSpeed);
    procedure OnTimer(Sedner:Tobject);virtual;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;

  public

    constructor Create(Aowner:Tcomponent);override;
    destructor Destroy; override;
    procedure paint;override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
        property Play:boolean
    read FPlay write SetPlay default False;

  published

    property Speed:Tspeed
    read  FSpeed write SetSpeed default 200;
    property Version: string read GetCop write SetCop;
    property Images: {$IFNDEF PDJ_D3} TCustomImageList {$ELSE} TImageList {$ENDIF}
      read FImages write SetImages;
    property ShowHint;
    property Align;
    property Visible;
    property Color;
    property Parentcolor;
    property Enabled;
    property OnClick;
    property OnDblClick;
    property DragCursor;
    property DragMode;
    property OnDragDrop;
    property OnDragOver;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property OnMouseEnter: TOnMouseOverEvent read FOnMouseOver write FOnMouseOver;
    property OnMouseExit: TOnMouseOutEvent read FOnMouseOut write FOnMouseOut;
    property PopupMenu;
    property AutoSize;
         {$IFDEF PDJ_D5up}
     property OnContextPopup;
     {$ENDIF}
    {$IFDEF PDJ_D3}
  {$ELSE}
    property DragKind;
    property Anchors;
    property Constraints;
    property OnStartDock;
    property OnEndDock;
  {$ENDIF}

  end;

procedure Register;

implementation



procedure Register;
begin
  RegisterComponents('PDJ', [TAnima]);
end;

constructor TAnima.Create(AOwner:TComponent);
begin
inherited;
ControlStyle := ControlStyle + [csReplicatable];
height:=40;
width:=40;
FPlay:=false;
FSpeed:=200;
Timer:=TTimer.Create(Self);
Timer.Interval:= FSpeed;
Timer.OnTimer:=OnTimer;
FCop:='Version 2.00, Copyright  2000-2001 by Peric, E-mail: pericddn@ptt.yu';
FImageChangeLink := TChangeLink.Create;
FImageChangeLink.OnChange := ImageListChange;

end;

procedure TAnima.CMMouseEnter(var AMsg: TMessage);
begin
if Assigned(FOnMouseOver) then FOnMouseOver(Self);
end;

procedure TAnima.CMMouseLeave(var AMsg: TMessage);
begin
if Assigned(FOnMouseOut) then FOnMouseOut(Self);
end;

function TAnima.CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := True;
  If FImages=nil then Exit;
  if not (csDesigning in ComponentState) or (FImages.Width > 0) and
    (FImages.Height > 0) then
  begin
    if Align in [alNone, alLeft, alRight] then
      NewWidth := FImages.Width;
    if Align in [alNone, alTop, alBottom] then
      NewHeight := FImages.Height;
  end;
end;

destructor TAnima.Destroy;
begin
  FImageChangeLink.Free;
  inherited Destroy;
end;

procedure TAnima.CmVisibleChanged(var Message: TWmNoParams);
begin
  inherited;
  Repaint;
end;

procedure TAnima.CmColorChanged(var Message: TWMNoParams);
begin
  inherited;
  Repaint;
end;

 procedure TAnima.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FImages) then FImages := nil;
  repaint;
end;

 procedure TAnima.Paint;
var Th,Lh:integer; R:Trect;
begin
  
 if FImages <> nil then begin
 R:=clientRect;
Th:=(height-FImages.Height)div 2;
Lh:=(width-FImages.width)div 2;
canvas.brush.color:=color;
canvas.Fillrect(r);
FImages.Draw(Canvas, Lh, Th, 0);
end
else
begin
R:=clientRect;
canvas.brush.color:=color;
canvas.Fillrect(r);
end;
 end;


procedure TAnima.SetImages(Value: {$IFNDEF PDJ_D3} TCustomImageList {$ELSE} TImageList {$ENDIF});
begin
  if FImages <> nil then
    FImages.UnRegisterChanges(FImageChangeLink);
  FImages := Value;
  if FImages <> nil then
  begin
    FImages.RegisterChanges(FImageChangeLink);
    FImages.FreeNotification(Self);
  end;
  if AutoSize and (FImages.Width > 0) and (FImages.Height > 0) then
	SetBounds(Left, Top, FImages.Width, FImages.Height);  
  Invalidate;
end;

procedure TAnima.ImageListChange(Sender: TObject);
begin
  if AutoSize and (FImages.Width > 0) and (FImages.Height > 0) then
	SetBounds(Left, Top, FImages.Width, FImages.Height);
  Invalidate;
end;


 function TAnima.GetCop: string;
begin
  Result:=FCop;
end;

procedure TAnima.SetCop(const Value: string);
begin
  FCop:=FCop;
end;

 procedure TAnima.SetPlay(APlay:boolean);
 begin
 FPlay:=APlay;
 if csDesigning in ComponentState then
 Exit;
 Timer.enabled:=FPlay;
 end;

 procedure TAnima.SetSpeed(value:TSpeed);
 begin
  if value <> FSpeed then
  begin
    FSpeed := value;
   Timer.interval:=FSpeed;
  end;
end;


 procedure TAnima.OnTimer(Sedner:Tobject);

 begin
 if csDesigning in ComponentState then begin
 Timer.Enabled:=False;
 Exit;
 end;
 RunAni;
 end;

Procedure TAnima.Animate;
var Th,Lh:integer;
begin
if not Assigned(FImages) then exit;
Th:=(height-FImages.Height)div 2;
Lh:=(width-FImages.width)div 2;
FImages.Draw(Canvas, Lh, Th, x);
end;

Procedure TAnima.RunAni;
var r:TRect;
begin
if not FPlay then exit;
if not Assigned(FImages) then exit;
if not visible then exit;
R:=clientRect;
canvas.brush.color:=color;
canvas.Fillrect(r);
Animate;
if (x < FImages.Count-1) then x := x + 1
else x := 0;
end;
end.
